#include "ahandler.h"

AHandler::AHandler() {
   NewKeyValue = 0;
   theMap.InitHashTable(257);
   return;
};

UINT AHandler::Add(UINT size) {
   CUIntArray * a = new CUIntArray;
   UINT NewKey = NewKeyValue;
   NewKeyValue++;
   a->SetSize(size);
   theMap.SetAt(NewKey,a);
   return NewKey;
};

BOOL AHandler::Remove(UINT arraynum) {
   CUIntArray * a;
   if (theMap.Lookup(arraynum,a) == 0)
      return FALSE;
   a->RemoveAll();
   delete a;
   theMap.RemoveKey(arraynum);
   return TRUE;
};

BOOL AHandler::Set(UINT arraynum, UINT recnum, UINT value) {
   CUIntArray * a;
   if (theMap.Lookup(arraynum,a) == 0)
      return FALSE;
   if ((UINT) a->GetSize() <= recnum)
      return FALSE;
   a->SetAt(recnum,(UINT) value);
   return TRUE;
};

UINT AHandler::Get(UINT arraynum, UINT recnum) {
   CUIntArray * a;
   if (theMap.Lookup(arraynum,a) == 0)
      return 0;
   if ((UINT) a->GetSize() <= recnum)
      return 0;
   return (UINT) a->GetAt(recnum);
};

AHandler::~AHandler() {
   POSITION pos = theMap.GetStartPosition();
   while(pos != NULL)
   {
      CUIntArray * a;
      UINT KeyNum;
      theMap.GetNextAssoc(pos,KeyNum,a);
      a->RemoveAll();
      delete a;
   }
   theMap.RemoveAll();
}

