#define VC_EXTRALEAN

#include <afxwin.h>
#include <afxext.h>
#include <afxdisp.h>

class CRemoteAhWnd : public COleDispatchDriver
{
public:
   void UserAdd();
   void DropUser();
   UINT NumUsers();
   UINT AddArray(UINT size);
   BOOL RemoveArray(UINT arraynum);
   BOOL SetRecord(UINT arraynum, UINT recnum, UINT value);
   UINT GetRecord(UINT arraynum, UINT recnum);
   void Close();
};

class CArrayfApp : public CWinApp
{
public:
   virtual BOOL InitInstance();
   CRemoteAhWnd ah;
private:
   void SetFromFile(UINT arraynum,LPCTSTR fName);
   void SetFromWinSel(UINT arraynum,LPCTSTR fName);
   void PostMsg(LPCTSTR Msg);
   void PostResult(UINT Result);
   void PostBResult(BOOL BResult);
};

