&routine csv

&define i -9 &var
&define tok -10 &var
&define opt -11 &var
&define in -12 &var
&define toknum -13 &var
&define num -14 &var
&define len -15 &var
&define chr -16 &var
&define quote -17 &var

&if &eq "x%-1" "x" &do
   &delim < >
   &type "Usage:  &r CSV [COUNT/EXTRACT] [string] {token_number}"
   &delim [ ]
   &return
&end
&extract [opt] -1 1
&if &eq "x[opt]" "x#" &do
   &sv [opt] COUNT
&end
&if &ne "COUNT" "[opt]" &and &ne "EXTRACT" "[opt]" &do
   &type "Option must be COUNT or EXTRACT."
   &return
&end
&value [in] -2
&if &eq "x[in]" "x" &do
   &type "Input string is blank."
   &return
&end
&value [toknum] -3
&if &eq "EXTRACT" "[opt]" &and &eq "x[toknum]" "x" &do
   &type "Token number not specified."
   &return
&end

&sv [i] 1
&sv [tok] 1
&sv [num] 1
&length [len] "[in]"
&sv [quote] .FALSE.
&while &rn [i] 1 [len] &do
   &value [chr] [in] [i] [i]
   &if &eq "'" "[chr]" &do
      &if &eq [quote] .TRUE. &do
         &value [chr] [in] %<[i] + 1> %<[i] + 1>
         &if &eq "'" "[chr]" &do
            &inc [i]
         &else
            &sv [quote] .FALSE.
         &end
      &else
         &sv [quote] .TRUE.
      &end
   &elseif &eq "," "[chr]" &do
      &if &eq [quote] .FALSE. &do
         &if &eq "EXTRACT" "[opt]" &do
            &if &eq [toknum] [num] &do
               &value [chr] [in] [tok] %<[i] - 1>
               &return "[chr]"
            &else
               &cv [tok] [i] + 1
            &end
         &end
         &inc [num]
      &end
   &end
   &inc [i]
&end
&if &eq EXTRACT [opt] &do
   &if &eq [toknum] [num] &do
      &value [chr] [in] [tok] [len]
      &return "[chr]"
   &else
      &type "Bad token number."
      &return
   &end
&end
&return [num]

