#define VC_EXTRALEAN

#include <afxwin.h>
#include <afxext.h>
#include <afxdisp.h>
#include "ahandler.h"

class CAhApp : public CWinApp
{
public:
   virtual BOOL InitInstance();
};

class CAhWin : public CFrameWnd
{
public:
   CAhWin();
   afx_msg void UserAdd();
   afx_msg void DropUser();
   afx_msg UINT NumUsers();
   afx_msg UINT AddArray(UINT size);
   afx_msg BOOL RemoveArray(UINT arraynum);
   afx_msg BOOL SetRecord(UINT arraynum, UINT recnum, UINT value);
   afx_msg UINT GetRecord(UINT arraynum, UINT recnum);
   afx_msg void Close();
   BOOL RegisterActive();

protected:
   BOOL m_bAutoDelete;
   DWORD m_dwRegister;
   AHandler ah;
   UINT NumOfUsers;

   virtual ~CAhWin();
   virtual void PostNcDestroy();
   DECLARE_DISPATCH_MAP()
   DECLARE_DYNCREATE(CAhWin)
   DECLARE_OLECREATE(CAhWin)
};

#ifndef IMPLEMENT_OLECREATE2
#define IMPLEMENT_OLECREATE2(class_name, external_name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
   AFX_DATADEF COleObjectFactory class_name::factory(class_name::guid, \
   RUNTIME_CLASS(class_name), TRUE, _T(external_name)); \
   const AFX_DATADEF GUID class_name::guid = \
   { l, w1, w2, { b1, b2, b3, b4, b5, b6, b7, b8 } };
#endif // IMPLEMENT_OLECREATE2
