&routine ap_run

ADDITEM VEG.AAT VEG.AAT T_VEG 11 11 I
ADDITEM VEG.AAT VEG.AAT T_LT 1 1 I
ADDITEM VEG.AAT VEG.AAT T_RT 1 1 I
ARCPLOTW ap_proc
DROPITEM VEG.AAT VEG.AAT T_VEG
DROPITEM VEG.AAT VEG.AAT T_LT
DROPITEM VEG.AAT VEG.AAT T_RT
&return

&routine ap_proc

CALC VEG ARC TYPE = 0
MOVEITEM VEG ARC ' ' TO TYPE_TEXT
CALC VEG ARC T_VEG = VEG_
CALC VEG ARC VEG_ = LPOLY_
JOIN VEG.AAT VEG.PAT VEG_
CALC VEG ARC T_LT = #TYPE
CALC VEG ARC VEG_ = RPOLY_
CALC VEG ARC T_RT = #TYPE
JOIN OFF
RES VEG ARC T_LT <> 0 AND T_RT <> 0
&r ap_curs VEG ARC
JOIN VEG.AAT LUT.VEGB TYPE
MOVEITEM VEG ARC #TYPE_TEXT TO TYPE_TEXT
JOIN OFF
ASEL VEG ARC
CALC VEG ARC VEG_ = T_VEG
QUIT
&return

&routine ap_doit

CALC VEG ARC -1 = T_LT * T_RT
&if &eq %-1 2 &do
   CALC VEG ARC TYPE = 1
&elseif &eq %-1 3 &do
   CALC VEG ARC TYPE = 2
&elseif &eq %-1 4 &do
   CALC VEG ARC TYPE = 3
&elseif &eq %-1 6 &do
   CALC VEG ARC TYPE = 4
&elseif &eq %-1 8 &do
   CALC VEG ARC TYPE = 5
&elseif &eq %-1 12 &do
   CALC VEG ARC TYPE = 6
&else
   &echo &debug
&end
&return

&routine ap_curs

&define cover -1 &var
&define feature -2 &var
&define numrec -11 &var
&define arraynum -12 &var
&define i -13 &var
&define id -14 &var
&define wksp -18 &var
&define temp -19 &var
&if &eq "x[cover]" "x" &do
   &delim < >
   &type "Usage:  &r ap_curs [cover] [feature]"
   &return
   &delim [ ]
&end
&rem **** initialize cursor
&value [wksp] WKSP
&value [temp] ARC
WIN SEL W [cover] [feature] [wksp]t$sel.lis
SHOW RESELECT [numrec] 0
&if &eq [numrec] 0 &do
   &type "ERROR: No records in selection set"
   & DEL [wksp]t$sel.lis
   &return
&end
WIN PATH [temp]\APPS
&type "Starting server..."
WIN RUN ah
&type "Initializing cursor..."
WIN RUNW arrayf U
WIN RUNW arrayf A [numrec]
WIN CB R
&value [arraynum] 1
WIN RUNW arrayf W [arraynum] [wksp]t$sel.lis
&rem **** loop through record set
&sv [i] 0
&while &rn [i] 0 %<[numrec] - 1> &do
   WIN RUNW arrayf G [arraynum] [i]
   WIN CB R
   &value [id] 1
   RES [cover] [feature] $RECNO IN {[id]}
   &rem **** manipulate record
   &type "Processing record [id]..."
   &run ap_doit
   ASEL [cover] [feature]
   &inc [i]
&end
&rem **** remove cursor
&type "Removing cursor..."
WIN RUNW arrayf R [arraynum]
WIN RUNW arrayf D
WIN RUNW arrayf N
WIN CB R
&value [i] 1
&if &eq [i] 0 &do
   &type "Closing server..."
   WIN RUNW arrayf C
&end
&rem **** restore selection set
WIN SEL R [cover] [feature] [wksp]t$sel.lis
& DEL [wksp]t$sel.lis
&return
